> For the complete documentation index, see [llms.txt](https://docs.crosscurve.fi/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.crosscurve.fi/developer-documentation/integration-guide-old/direct-integration-with-rest-api/transaction-tracking.md).

# Transaction Tracking

Track the status of a cross-chain swap with `GET /transaction/{requestId}`.

**Obtaining the requestId**

The `requestId` is emitted in the `ComplexOpProcessed` event on the source chain after the transaction is confirmed. You can extract it from the transaction receipt.

**Response structure**

```json
{
  "status": "inProgress",
  "inconsistency": false,
  "source": {
    "chainId": 11155111,
    "transactionHash": "0x...",
    "from": "0x...",
    "events": [],
    "status": "completed"
  },
  "oracle": {
    "relayChainId": 11155111,
    "requestId": "0x...",
    "status": "inProgress",
    "height": null,
    "epoch": null,
    "time": null
  },
  "destination": {
    "chainId": 64165,
    "transactionHash": null,
    "events": [],
    "emergency": false,
    "status": "inProgress",
    "bridgeState": {},
    "error": null
  },
  "data": null
}
```

The response contains three sub-objects representing each phase of the cross-chain operation:

| Sub-object    | Description                     |
| ------------- | ------------------------------- |
| `source`      | Status on the originating chain |
| `oracle`      | Validator confirmation status   |
| `destination` | Status on the target chain      |

`destination.emergency` becomes `true` if over 30 minutes pass without completion.

**Top-level status values**

| Status       | Final? | Description                                  |
| ------------ | ------ | -------------------------------------------- |
| `inProgress` | No     | Transaction is being processed               |
| `completed`  | Yes    | Successfully completed                       |
| `failed`     | Yes    | An error occurred                            |
| `reverted`   | Yes    | Reverted (emergency completion is available) |
| `retry`      | No     | Delivery is being retried                    |
| `canceled`   | Yes    | Transaction was canceled                     |

**Polling recommendations**

* Poll every **10-15 seconds**.
* Set a **15 minute** timeout.
* Stop polling when the top-level `status` reaches a final state (`completed`, `failed`, `reverted`, or `canceled`).

***


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.crosscurve.fi/developer-documentation/integration-guide-old/direct-integration-with-rest-api/transaction-tracking.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
